#!/usr/bin/env python
# -*- coding: utf-8 -*-
# cdbrillo.py by:
#   Ignacio Rodríguez <ignacio@sugarlabs.org>
# LICENCIA: GPLv3
import gtk
import gobject
MAS_BRILLO = gtk.Image()
MAS_BRILLO.set_from_file('icons/masbrillo.svg')
MENOS_BRILLO = gtk.Image()
MENOS_BRILLO.set_from_file('icons/menosbrillo.svg')
SALIR = gtk.Image()
SALIR.set_from_file('icons/salir.svg')


class Cambiame:
        """ Un simple app que resuelve todos los problemas del usuario,
         en cuanto al brillo """
        def __init__(self):
            """ Init del programa """
            self.estado = gtk.StatusIcon()
            pixbuf = gtk.gdk.pixbuf_new_from_file('icons/sun.svg')
            self.estado.set_from_pixbuf(pixbuf)

            self.estadoitem = gtk.MenuItem()
            self.estadoitem.set_sensitive(False)

            self.menu = gtk.Menu()
            self.menu.append(self.estadoitem)
            self.menu.append(gtk.SeparatorMenuItem())
            self.subirbrillo = gtk.ImageMenuItem()
            self.subirbrillo.set_image(MAS_BRILLO)
            self.subirbrillo.set_label('Aumentar brillo')
            self.subirbrillo.connect('activate', self.setear, True)
            self.bajarbrillo = gtk.ImageMenuItem()
            self.bajarbrillo.set_image(MENOS_BRILLO)
            self.bajarbrillo.connect('activate', self.setear, False)
            self.bajarbrillo.set_label('Disminuir brillo')
            self.menu.append(self.subirbrillo)
            self.menu.append(self.bajarbrillo)
            self.menu.append(gtk.SeparatorMenuItem())
            self.salir = gtk.ImageMenuItem()
            self.salir.set_image(SALIR)
            self.salir.set_label('Salir')
            self.salir.connect('activate', lambda x: gtk.main_quit())
            self.menu.append(self.salir)
            gobject.timeout_add(50, self.estadoreturn)
            self.estado.connect('popup-menu', self.popup_menu_cb, self.menu)

        def popup_menu_cb(self, widget, event, time, data=None):
            """Despliega el menu"""
            self.menu.show_all()
            self.menu.popup(None, None, gtk.status_icon_position_menu,
                                3, time, self.estado)

        def estadoreturn(self):
            """Devuelve el estado del archivo brillo"""
            archi = open('/sys/class/backlight/cmpc_bl/brightness', 'r')
            estadof = archi.read()
            estado = estadof[:-1]
            archi.close()
            self.estadoitem.set_label('Brillo actual:' + estado + "/7")
            gobject.timeout_add(50, self.estadoreturn)

        def setear(self, widget, sube):
            """Aumenta o disminuye el brillo"""
            af = open("/sys/class/backlight/cmpc_bl/brightness", 'r')
            actual = int(af.read())
            af.close()
            editar = open("/sys/class/backlight/cmpc_bl/brightness", "w")
            if sube:
                actual += 1
                if actual <= 7:
                    editar.write(str(actual))
                else:
                    pass
            if not sube:  # Baja :P #
                actual -= 1
                if actual >= 0:
                    editar.write(str(actual))
if __name__ == "__main__":
    a = Cambiame()
    gtk.main()
